// R_COM.H : RS232-Klasse
// G. TAMM, DF9ZO 1999-2007
//-------------------------
#ifndef _R_COM_H_
#define _R_COM_H_
//--------------------
#ifndef _R_VAR_H_
  #include "R_VAR.H"
#endif
#ifndef _R_DIV_H_
  #include "R_DIV.H"
#endif
#ifndef _R_LIB_H_
  #include "R_LIB.H"
#endif
#include "afxwin.h"
//--------------------
/*
 COMX= 0 COM1
 COMX= 1 COM2
 COMX= 2 COM3
 -
 COMX=19 COM20

 BAUD=0  75
 BAUD=1  150
 BAUD=2  300
 BAUD=3  600
 BAUD=4  1200
 BAUD=5  2400
 BAUD=6  4800
 BAUD=7  9600
 BAUD=8  19200
 BAUD=9  38400
 BAUD=10 57600
 BAUD=11 115200

 DATA=0  4
 DATA=1  5
 DATA=2  6
 DATA=3  7
 DATA=4  8

 STOP=0	1
 STOP=1	1.5
 STOP=2	2

 PARI=0	ODD
 PARI=1	EVEN
 PARI=2	MARK
 PARI=3	SPACE
 PARI=4	NO

 PROT=0	RTS/CTS
 PROT=1	DTR/DSR
 PROT=2	Xon/Xoff
 PROT=3	NO
*/
//+Globale Variablen+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
extern const char COMX_s[20][7];
extern const char BAUD_s[12][7];
extern const int  BAUD_n[12];
extern const char DATA_s[5] [2];
extern const int  DATA_n[5];
extern const char STOP_s[3] [4];
extern const char PARI_s[5] [6];
extern const char PROT_s[4] [9];

extern int        COMAvail[];//0=Port NOT available, 1=Port available
//+Funktionen++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void COMTest_Single(int comport);
//Testet Verfuegbarkeit eines bestimmten Ports
void COMTest_Complete(int shmsg=1);
//Testet Verfuegbarkeit aller Ports
//COMSETTINGSDlg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class COMSETTINGSDlg : public CDialog
{
	DECLARE_DYNAMIC(COMSETTINGSDlg)

public:
	COMSETTINGSDlg(CWnd* pParent = NULL);   // Standardkonstruktor
	virtual ~COMSETTINGSDlg();

// Dialogfelddaten
	enum { IDD = IDD_COMSETTINGS_DLG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

	DECLARE_MESSAGE_MAP()
public:    
    int     m_pollmode;
    CString m_polliv;
    virtual BOOL OnInitDialog();
    afx_msg void OnOK();
};
//COM-Klasse+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class COM
{
 public:
   int  PortIsActive;			//0=NOT active, 1=active
   int  ErrorNum;
   int  LineStatus;
   int  oldMSR[4],actMSR[4];	//0=RLSD, 1=RING, 2=CTS, 3=DSR
   int  RLSD,RING,CTS,DSR;
   char PortName[5];
   char ErrTxt[100];
   //Standardkonstruktor
   COM();
   //Destruktor
   ~COM();
   //Methoden
   void ShComError(void);
   int  Open(int comx=2,int baud=9600,int data=8,int stop=1,
			 int pari=4,int prot=2,
			 int rxbuf=5000,int txbuf=1000);
   int  Close(void);
   //-----------------------
   int ReadChar(void);
   //-----------------------
   int WriteChar(int ch);
   int WriteStr(char *src,int mode);
   //Sendet NUR, wenn TXbuf ausreichend f. kompletten String
   //Sendet terminierendes '\0' NICHT MIT
   //mode=0 -> nur src  mode=1 -> src+CR(13)  mode=2 -> src+CR(13)+LF(10)
   //-----------------------
   int RXBufFree(void);
   int RXBufUsed(void);
   int TXBufFree(void);
   int TXBufUsed(void);
   //-----------------------
   int ClrRXBuf(void);
   int ClrTXBuf(void);
   //-----------------------
   void SetDTR(void);
   void ResDTR(void);
   void SetRTS(void);
   void ResRTS(void);
   //-----------------------
   int  ReadMSR(void);// 1=(oldMSR != actMSR)  0=(oldMSR == actMSR)
   //-----------------------
   //int Break(long milliseconds=300);
   //int SoftwareOverrunError(int clear=UNCHANGED);
   //int ParityError(int clear=UNCHANGED);
   //int BreakDetect(int clear=UNCHANGED);
   //int FramingError(int clear=UNCHANGED);
   //int HardwareOverrunError(int clear=UNCHANGED);
   //Radiofunktionen+++++++++++++++++++++++++++++++
   int TestCmd(int subcmd);
   //Funktion zum Test
   int AskFREQ();
   //Fragt Frequenz von Radio ab
   void SetFREQ(char *freqstr);//Respond OK
   //Sendet NUR, wenn TXbuf ausreichend f. komplette Zeichenfolge
   //Erwartet normgerechten freqstr
   void RXBufferToFstr(int arrmaxind);
   //Macht normgerechten Fstr aus RX-Buffer
   //-----------------------
   int AskMODE();
   //Fragt Mode von Radio ab
   void SetMODE(int moind,int fiind);//Respond OK
   //moind = Indexierung Modes
   void RXBufferToMoFi(int mo_ind,int fi_ind);
   //Macht Mode- und FilterIndex aus RX-Buffer
   //-----------------------
   void SwitchANT(int ant);
   void SwitchATT(int att);//Respond OK
   void SwitchPAMP(int pamp);//Respond OK
   void SwitchAGC(int agc);
   void SwitchDUP(int dup);//Respond OK
   void SwitchVFO(int vfo);//Respond OK
   //0=VFO A, 1= VFO B
   void SwitchVFOsEQUAL();
   //Gleicht VFOs an
   void SwitchVM(int vm);//Respond OK
   //0=VFO, 1=MEM
   void SwitchANF(int anf);
   //Schaltet ANT/ATT/PAMP usw. um
   //-----------------------
   void SwitchNR(int nr);
   //Schaltet NR um
   void AskNR_lev();
   void SetNR_lev(int nrlev_n);
   //Setzt NR-Level
   //-----------------------
   void SwitchNB(int nb);
   //Schaltet NB um
   void AskNB_lev();
   void SetNB_lev(int nblev_n);
   //Setzt NB-Level
   void AskNB_wid();
   void SetNB_wid(int nbwid_n);
   //Setzt NB-Width
   //-----------------------
   void AskSQL_SW_oc(); 
   //Erfragt SQL-Zustand via Radio-SW
   int  AskSQL_HW_oc();
   //Erfragt SQL-Zustand via Radio-HW 
   void AskSQL_lev();
   //Erfragt SQL-Level
   void SetSQL_lev(int sqllev_n);
   //Setzt Squelch-Level
   //-----------------------
   void AskAF_lev();
   void SetAF_lev(int af_n);
   //-----------------------
   void AskRF_lev();
   void SetRF_lev(int rf_n);
   //-----------------------
   void AskSM_lev();
   //S-Meter
   //-----------------------
   void AskPBTH();
   void SetPBTH_lev(int pbth_n);
   void AskPBTL();
   void SetPBTL_lev(int pbtl_n);
   //-----------------------
   void AskCWSPEED();
   //Fragt Keyer-Speed ab;
   void SetCWSPEED(int cwspeed_n);
   //Setzt Keyer-Speed: 0-255
   //-----------------------
   void AskTXPWR();
   //Fragt eingestellte Sendeleistung ab;
   void SetTXPWR(int txpwr_n);//Respond OK
   //Setzt Sendeleistung: 0-255 (27=10W, 53=20 W) 
   void SetRX_TX(int rx_tx);
   //0=RX, 1=TX
   //-----------------------
   void AskRTTY_MF();
   void SetRTTY_MF(int mf);
   void AskRTTY_SH();
   void SetRTTY_SH(int sh);
   void AskRTTY_KP();
   void SetRTTY_KP(int kp);
   void AskRTTY_RXDEC();
   void SetRTTY_RXDEC(int rxdec);
   void AskRTTY_TPF();
   void SetRTTY_TPF(int tpf);
   //-----------------------
   void SetTuStep(int stepind);//Respond OK
   //Setzt Tuning Step
   //-----------------------
   void AskMEM(int bank,int memnum);
   //bank=1(A)-5(E), memnum 1-99
   void SetMEM(int bank,int memnum,char *freqstr,int moind,int fiind,int dup,char *memtxt);
   //Speicher schreiben: 0x1A  0x00   
   void SetMEM_FromVFO();
   //Speicher schreiben: 0x09 
   void SetMEM_Bank(int bank);
   //Setzt Bank
   void SetMEM_ToNum(int memnum);
   //Setzt memnum
   void SetMEM_CLR();
   //Loescht Radio-Memory
   //-----------------------
   void SendNOTOK();
   //Erzeugt Rueckgabe NOT OK
   //----------------------------------------------
   int AskCOM_SPEC(int retexp);
   int AskCOM_IDLE();
   int ReadCOM();
   //Fragt auf Events Radio ab
   //return-Werte: s. R_Com.cpp
   //Radiofunktionen Ende++++++++++++++++++++++++++
 public:
   int RXb[100];  //RX-Buffer f. Radio
 private:
   HANDLE hCom;
   DCB  dcb,olddcb;
   int  ComCOMX,ComDATA,ComSTOP,ComBAUD,ComPARI,ComPROT;
   int  RXbuf,TXbuf;
   char errtxt1[10],errtxt2[10],errtxt3[10];
   int TXstr[100]; //Sendestring
   //int RXb[100];//Buffer f. Radio
   int RXc;       //Counter f. Buffer
};
//Globals++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
extern COM comport; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#endif // _R_COM_H_
/*
SetRTS;  {RTS to log. low=+12V  ready to send    }
ResRTS;  {RTS to log. high=-12V NOT ready to send}
SetDTR;  {DTR to log. low=+12V }
ResDTR;  {DTR to log. high=-12V}
RTS and DTR are log. low when COM is opened
*/
